"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const BaseParse_1 = require("./BaseParse");
const PictResource_1 = require("../resourceParsers/PictResource");
const pngjs_1 = require("pngjs");
const PictImage_1 = require("../../../NovaDataInterface/PictImage");
function PictImageMultiParse(pict, notFoundFunction) {
    return __awaiter(this, void 0, void 0, function* () {
        var base = yield BaseParse_1.BaseParse(pict, notFoundFunction);
        var png;
        try {
            png = pngjs_1.PNG.sync.write(pict.png);
        }
        catch (e) {
            if (e instanceof PictResource_1.PNGError) {
                notFoundFunction("PICT " + base.id + " failed to parse");
                png = PictImage_1.DefaultPictImageData;
            }
            else {
                throw e;
            }
        }
        return {
            pict: base,
            image: png
        };
    });
}
exports.PictImageMultiParse = PictImageMultiParse;
;
//# sourceMappingURL=PictParse.js.map